/*
 * Copyright (C) 2009 SENJU Jiro
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <sys/resource.h>
#include <sys/time.h>
#include <unistd.h>

#include "resource.h"

/* the number of online processors */
int num_cpu(void)
{
	return sysconf(_SC_NPROCESSORS_ONLN);
}

/* the number of open file descriptors */
int num_fd(void)
{
	int err;
	struct rlimit rlim;

	err = getrlimit(RLIMIT_NOFILE, &rlim);
	if (!err) {
		err = rlim.rlim_cur;
		if (err == RLIM_INFINITY)
			err = 4096; /* local policy */
	}
	return err;
}
