
Me := $(lastword ${MAKEFILE_LIST})
include var.mk

BaseUrl = git://aufs.git.sourceforge.net/gitroot/aufs
AufsDir = aufs2-standalone.git
AufsUtilDir = aufs2-util.git

all:
	@echo \- Get linux-2.6.${KVer} and extract it under a dir named ${Linux26}
	@echo \- Get aufs by \"make -f ${Me} pull\"
	@echo \- Apply aufs patches to linux-2.6.${KVer} by \"make -f ${Me} apply\"
	@echo \- Build linux-2.6.${KVer} by \"cd ${Linux26} '&& make &&' make headers_install\" and reboot
	@echo \- Build aufs by \"make -f ${Me} build\"
	@echo \- Install aufs by \"make -f ${Me} install\" as superuser

clean:
	-for i in aufs2-standalone.git aufs2-util.git; \
	do test -d $${i} && ${MAKE} -C $${i} $@; \
	done
	${RM} aufs-build

realclean: clean
	${RM} -r ${AufsDir} ${AufsUtilDir} aufs-download

pull apply build install: %: aufs-%

########################################

aufs-download:
	git clone -q ${BaseUrl}/${AufsDir} ${AufsDir}
	git clone -q ${BaseUrl}/${AufsUtilDir} ${AufsUtilDir}
	touch $@

aufs-pull: aufs-download
	cd ${AufsDir} && \
	git checkout master && \
	git pull -q -n && \
	git checkout -q origin/aufs2.1-${KVer}

	cd ${AufsUtilDir} && \
	git checkout master && \
	git pull -q -n && \
	git checkout -q origin/aufs2.1

aufs-apply: aufs-pull
	for i in base standalone; \
	do patch -s -d ${Linux26} -p1 < aufs2-standalone.git/aufs2-$${i}.patch; \
	done
	@echo build ${Linux26} and reboot.

aufs-build:
	uname -r | fgrep -q 2.6.${KVer} || \
	echo Warning: aufs.mk expects linux-2.6.${KVer} is running
	${MAKE} -C aufs2-standalone.git CONFIG_AUFS_DEBUG=
	${MAKE} -C aufs2-util.git \
		CPPFLAGS="-I${Linux26}/usr/include -I${CURDIR}/aufs2-standalone.git/usr/include"
	touch $@

aufs-install: aufs-build
	${MAKE} -C aufs2-standalone.git install
	${MAKE} -C aufs2-util.git install
	touch $@
