
Me := $(lastword ${MAKEFILE_LIST})
include var.mk

CLoopMajorVer = 2.636
CLoopVer = ${CLoopMajorVer}-1
CLoopUrl = debian-knoppix.alioth.debian.org/packages/cloop
CLoopDir = cloop-${CLoopMajorVer}

all:
	@echo \- Get linux-2.6.${KVer} and extract it under a dir named ${Linux26}
	@echo \- Get cloop by \"make -f ${Me} download\"
	@echo \- Boot linux-2.6.${KVer}
	@echo \- Apply a patch to cloop by \"make -f ${Me} apply\"
	@echo \- Build linux-2.6.${KVer} by \"cd ${Linux26} '&& make &&' make headers_install\"
	@echo \- Build cloop by \"make -f ${Me} build\"
	@echo \- Install cloop by \"make -f ${Me} install\" as superuser

clean:
	${RM} -r ${CLoopDir} cloop-apply

realclean:
	${RM} ${CLoopUrl}/cloop_${CLoopVer}.tar.gz cloop-download
	test ! -d ${CLoopUrl} || \
	find debian-knoppix.alioth.debian.org -depth -type d | \
	xargs -r rmdir --ignore-fail-on-non-empty

download apply build install: %: cloop-%

########################################

cloop-download:
	-wget --no-verbose -x http://${CLoopUrl}/cloop_${CLoopVer}.tar.gz
	touch $@

cloop-apply: cloop-${CLoopMajorVer}-2.6.${KVer}.patch cloop-download
	tar -xpzf ${CLoopUrl}/cloop_${CLoopVer}.tar.gz
	patch -s -p1 < $<
	touch $@

cloop-build: cloop-apply
	${MAKE} -C ${CLoopDir} KERNEL_DIR=${Linux26}

cloop-install: cloop-build
	cd ${CLoopDir} && \
	${MAKE} -C ${Linux26} M=${CURDIR}/${CLoopDir} modules_install
